Option explicit

'-----------------------------------------------------------------
'-                       -
'-      ...                              -
'-----------------------------------------------------------------
'-        2.5.0.90        -
'-     20.03.2006 .                              -
'-   !      -
'-   VBS              -
'-          ...     -
'-----------------------------------------------------------------

const HZ = "1" '0

'      
const EZP_DATA_FILE = "Temp\ezparm02.tmp"

const SILENT_LEVEL_WINDOWS = 3
const SILENT_LEVEL_INTERACTIVE = 4

const BASE64_TYPE = 0
const DER_TYPE = 2

'enim PROFILESTORETYPE ()
const REGISTRY_STORE = 0

'enum DATATYPE ( )
const SIGNED_DATA = 0
const DT_ENVELOPED_DATA = 1 '3
const DT_PLAIN_DATA = 2 '0

const DECRYPT_WIZARD_TYPE = 4  'NEW 1024

const ALL_OK = 0

'    
const CORRECT = 0
const CERT_NO_TRUST = 1
const UNSUFFICIENT_INFO = 2
const UNCORRECT = 3
const INVALID_CERTIFICATE_BLOB = 4
const CERTIFICATE_TIME_EXPIRIED = 5
const CERTIFICATE_NO_CHAIN = 6
const CERTIFICATE_CRL_UPDATING_ERROR = 7
const CERTIFICATE_STORE_OPEN_ERROR = 8
const CRL_PROCESSING_ERROR = 9
const CRL_TIME_EXPIRIED = 10
const CERTIFICATE_CRL_PROCESSING_ERROR = 11
const CERTIFICATE_IN_CRL = 12

const VERIFYING_SIGNATURE_INDEX = 0

const CERT_AND_SIGN = 0
const SIGN_ONLY = 1

'    VBS
Dim objArgs
Set objArgs = WScript.Arguments 

dim CheckResult 
Dim objProfile, objProfileStore, objProfiles
Dim oPKCS7Message

Dim FlagProfile
FlagProfile = ""

'       ,   
         
Set objProfileStore = CreateObject("DigtCrypto.ProfileStore")
objProfileStore.Open( REGISTRY_STORE )  '  
Set objProfiles = objProfileStore.Store '  

If objProfiles.Count > 0 then

'  Set objProfile = objProfiles.DefaultProfile '   

   If objArgs.Count = 2 then

      '    2 ( )
      '    
      Set objProfile = objProfiles.DefaultProfile
      FlagProfile  = objProfile.ID

   else

      '   3  ( +  )
      ' -   -   
      Dim CountP
      CountP = objProfiles.Count

      Dim FProfil     '     
      Dim Counter     '   
      Dim NameProfil  '   -    (3 )
      Dim IDProfil    ' ID  

      ' ,   ID  
      IDProfil = ""

      '     
      NameProfil = objArgs(2)

      '       
      For Counter = 0 to CountP - 1

        If IDProfil = "" then

           '   ID  
           ' -       
           Set FProfil = objProfiles.Item(Counter)

           If FProfil.Name = NameProfil then

              '        
              IDProfil = FProfil.ID

              'WScript.Echo FProfil.Name
              'WScript.Echo FProfil.ID

           end If

        end If

      Next

      '    c   (NameProfil) -
      '       ID (IDProfil)

      If IDProfil <> "" then

         Set objProfile = objProfiles.Find(IDProfil)
         FlagProfile    = objProfile.ID

      end If 
   end If
else
   Set objProfile = CreateObject("DigtCrypto.Profile") '  
end if

' ---     ---

If FlagProfile <> "" then

   '   ,  ,   

   objProfile.SilentLevel = SILENT_LEVEL_WINDOWS
   objProfile.CollectData DECRYPT_WIZARD_TYPE        '     

   CheckResult = objProfile.CheckData( DECRYPT_WIZARD_TYPE ) ',    

   If CheckResult = ALL_OK then

      Set oPKCS7Message = CreateObject("DigtCrypto.PKCS7Message")
      oPKCS7Message.Profile = objProfile '   

      '   
      oPKCS7Message.Load objArgs(0), DT_ENVELOPED_DATA, ""

      oPKCS7Message.Decrypt HZ

      '  
      oPKCS7Message.Save EZP_DATA_FILE, BASE64_TYPE, DT_PLAIN_DATA

      '    
      oPKCS7Message.Load EZP_DATA_FILE, SIGNED_DATA, ""

      ' ,     
      dim CheckValdEZP
      CheckValdEZP = True

      ' ---   

      dim oSignatures
      set oSignatures = oPKCS7Message.Signatures

      If oSignatures.Count <= 0 then
          MsgBox "     ."
      else
          dim oSignature
          dim iVerifyStatus

          set oSignature = oSignatures.Item( VERIFYING_SIGNATURE_INDEX )
          iVerifyStatus = oSignature.Verify( CERT_AND_SIGN, "" )

          select case iVerifyStatus
              case CORRECT
                  'MsgBox " ."
              case CERT_NO_TRUST
                  'MsgBox " ."
                  'CheckValdEZP = False
              case UNSUFFICIENT_INFO
                  'MsgBox "    ."
                  'CheckValdEZP = False
              case UNCORRECT
                  'MsgBox " ."
                  'CheckValdEZP = False
              case INVALID_CERTIFICATE_BLOB
                  'MsgBox "   ."
                  'CheckValdEZP = False
              case CERTIFICATE_TIME_EXPIRIED
                  'MsgBox "   ."
                  'CheckValdEZP = False
              case CERTIFICATE_NO_CHAIN
                  'MsgBox "    ."
                  'CheckValdEZP = False
              case CERTIFICATE_CRL_UPDATING_ERROR
                  'MsgBox "    ."
                  'CheckValdEZP = False
              case CERTIFICATE_STORE_OPEN_ERROR
                  'MsgBox "    ."
                  'CheckValdEZP = False
              case CRL_PROCESSING_ERROR
                  'MsgBox "CRL ,      ."
                  'CheckValdEZP = False
              case CRL_TIME_EXPIRIED
                  'MsgBox "CRL ,     ."
                  'CheckValdEZP = False
              case CERTIFICATE_CRL_PROCESSING_ERROR
                  'MsgBox "   CRL  ."
                  'CheckValdEZP = False
              case CERTIFICATE_IN_CRL
                  'MsgBox "   CRL."
                  'CheckValdEZP = False
          end select

          ' 4     -   
          If objArgs.Count = 4 then

             '      

             dim UserOpenKey
             UserOpenKey = objArgs(3)
             'MsgBox UserOpenKey

             If UserOpenKey <> "" then

                '     

                dim oSFRT
                Set oSFRT = oSignature.Certificate

                dim oSFRTOpenKey
                oSFRTOpenKey = oSFRT.PublicKey(0)

                'MsgBox oSFRT.ID
                'MsgBox oSFRT.ThumbPrint
                'MsgBox oSFRTOpenKey

                '    

                If UserOpenKey <> oSFRTOpenKey then
                   'CheckValdEZP = False
                end If
             end If
          end If
      end if

      '        

      If CheckValdEZP = True then

         '    
         oPKCS7Message.Save objArgs(1), BASE64_TYPE, DT_PLAIN_DATA
      else
         MsgBox "         !"
      end If

      set oPKCS7Message = nothing

      ' ---      ---

      'Dim objFile_
      'Set objFile_ = CreateObject("Scripting.FileSystemObject")
      'objFile_.DeleteFile CStr(EZP_DATA_FILE)

      ' -------------------------------------------
   else
      MsgBox "      !"
   end if
else
   MsgBox "        !"
end If